## cloudcompare 2.11.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project( CloudCompareProjects )

option(BUILD_TESTING "" OFF)
include(CTest)

list( APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/" )

include( CMakePolicies )
include( CMakeSetCompilerOptions )

# Default debug suffix for libraries.
set( CMAKE_DEBUG_POSTFIX "d" )

# One shouldn't generate the BUILD project directly in the SOURCES folder!
if ( ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR} )
	if ( NOT SAME_BUILD_AND_SOURCE_FOLDER_WARNING_ALREADY_ISSUED )
		message(FATAL_ERROR "It is not advised to BUILD the binaries directly in the SOURCE folder!\n If you want to proceed with this option, just CONFIGURE the project once again" )
		set( SAME_BUILD_AND_SOURCE_FOLDER_WARNING_ALREADY_ISSUED TRUE )
	endif()
endif()

# Default install folders
# (on Windows - msvc generator - the '_debug' suffix is automatically added for debug configurations)
set( INSTALL_DESTINATIONS CloudCompare )

# RPATH Linux/Unix: (dynamic) libs are put in a subdir of prefix/lib,
# since they are only used by qCC/ccViewer
if( UNIX AND NOT APPLE )
	include( GNUInstallDirs )
	set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}/cloudcompare")
endif()

# CCViewer
OPTION( OPTION_BUILD_CCVIEWER "Check to compile CCViewer project" ON )

# Quad buffer stereo support
OPTION( OPTION_GL_QUAD_BUFFER_SUPPORT "Check to compile CloudCompare and ccViewer with Quad Buffer support" OFF )

# Define target folders
# (now that ccViewer can have its own plugins, qCC and ccViewer must fall in separate folders!
if(WIN32 OR APPLE) 
	set( CLOUDCOMPARE_DEST_FOLDER CloudCompare )
	set( CCVIEWER_DEST_FOLDER ccViewer )
	if (OPTION_GL_QUAD_BUFFER_SUPPORT)
		set ( CLOUDCOMPARE_DEST_FOLDER ${CLOUDCOMPARE_DEST_FOLDER}Stereo )
		set ( CCVIEWER_DEST_FOLDER ${CCVIEWER_DEST_FOLDER}Stereo )
	endif()
else()
	set( CLOUDCOMPARE_DEST_FOLDER bin )
	set( CCVIEWER_DEST_FOLDER bin )
endif()

# set default install folders
if( WIN32 )
    # (on Windows - msvc generator - the '_debug' suffix is automatically added for debug configurations)
    set( INSTALL_DESTINATIONS ${CLOUDCOMPARE_DEST_FOLDER} )
    
    if( ${OPTION_BUILD_CCVIEWER} )
        list( APPEND INSTALL_DESTINATIONS ${CCVIEWER_DEST_FOLDER} )
    endif()
elseif( APPLE )
	set( INSTALL_DESTINATIONS "${CLOUDCOMPARE_MAC_FRAMEWORK_DIR}" )
    
    if( ${OPTION_BUILD_CCVIEWER} )
        list( APPEND INSTALL_DESTINATIONS "${CCVIEWER_MAC_FRAMEWORK_DIR}" )
    endif()
elseif( UNIX )
	set( INSTALL_DESTINATIONS ${CMAKE_INSTALL_PREFIX}/bin )
endif()

# Load advanced scripts
include( CMakeInclude )

add_subdirectory( CC )

# Propagate the choice to use doubles for ScalarType
if ( ${USE_SCALAR_TYPE_DOUBLE} )
	add_definitions( -DSCALAR_TYPE_DOUBLE )
else()
	add_definitions( -DSCALAR_TYPE_FLOAT )
endif()

# Add external libraries
include( CMakeExternalLibs )

# Contrib. libraries (mainly for I/O)
include( contrib/AllSupport.cmake )

# Libs requested by both qCC & ccViewer
add_subdirectory( libs/CCFbo )
add_subdirectory( libs/qCC_db ) # must always be included after CCFbo (dependency)
add_subdirectory( libs/qCC_io ) # must always be included after qCC_db (dependency)
add_subdirectory( libs/qCC_glWindow ) # must always be included after qCC_db (dependency)
add_subdirectory( libs/qcustomplot )

# load plugins (potentially used by qCC and ccViewer)
add_subdirectory( plugins )

# qCC
add_subdirectory( qCC )

# CCViewer
if( ${OPTION_BUILD_CCVIEWER} )
	add_subdirectory( ccViewer )
endif()

=== CC/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

# Options
option( COMPILE_CC_CORE_LIB_WITH_QT "Check to compile CC_CORE_LIB with Qt (to enable parallel processing)" ON )
option( COMPILE_CC_CORE_LIB_WITH_CGAL "Check to compile CC_CORE_LIB with CGAL lib. (to enable Delaunay 2.5D triangulation with a GPL compliant licence)" OFF )
option( COMPILE_CC_CORE_LIB_WITH_TBB " Check to compile CC_CORE_LIB with Intel Threading Building Blocks lib (enables some parallel processing )" OFF )
option( COMPILE_CC_CORE_LIB_SHARED "Check to compile CC_CORE_LIB as a shared library (DLL/so)" ON )

# ScalarType as float (default) or double
option( OPTION_SCALAR_DOUBLE "Check to define ScalarType as double" OFF )

if ( OPTION_SCALAR_DOUBLE )
	add_definitions( -DSCALAR_TYPE_DOUBLE )
	set (USE_SCALAR_TYPE_DOUBLE ON PARENT_SCOPE)
else()
	add_definitions( -DSCALAR_TYPE_FLOAT )
endif()

# to compile CCLib only! (CMake implicitly imposes to declare a project before anything...)
project( CC_CORE_LIB VERSION 1.0 )

include ( CMakePolicies )
include ( CMakeSetCompilerOptions )

if (COMPILE_CC_CORE_LIB_WITH_CGAL)
	include( cmake/CGALSupport.cmake )
endif()

if (COMPILE_CC_CORE_LIB_WITH_TBB)
	include( cmake/FindTBB.cmake )
else()
	if (NOT WIN32)
		message( WARNING "CCLib configured without parallel algorithm capabilities - see COMPILE_CC_CORE_LIB_WITH_TBB" )
	endif()
endif()

# Additional dependencies (only Qt in fact)
if (COMPILE_CC_CORE_LIB_WITH_QT)
	include( CMakeExternalLibs )
endif()

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/include )

file( GLOB header_list include/*.h)
file( GLOB source_list src/*.cpp src/*.h)

if ( WIN32 )
	# Add Qt5 natvis file
	if ( COMPILE_CC_CORE_LIB_WITH_QT )
		list( APPEND header_list ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/windows/qt5.natvis )
		#message(${header_list})
	endif()
endif()

if (COMPILE_CC_CORE_LIB_SHARED)
	set( CMAKE_CXX_VISIBILITY_PRESET hidden )
	set( CMAKE_VISIBILITY_INLINES_HIDDEN 1 )
	
	add_library( ${PROJECT_NAME} SHARED ${header_list} ${source_list} )
else()
	add_library( ${PROJECT_NAME} STATIC ${header_list} ${source_list} )
	
	target_compile_definitions( ${PROJECT_NAME} PRIVATE CC_CORE_LIB_STATIC_DEFINE )	
endif()

# generate the export header file
include( GenerateExportHeader )

generate_export_header( ${PROJECT_NAME}
	EXPORT_FILE_NAME ${CMAKE_CURRENT_SOURCE_DIR}/include/CCCoreLibExport.h
	EXPORT_MACRO_NAME CC_CORE_LIB_API
)

if (COMPILE_CC_CORE_LIB_WITH_CGAL)
	target_link_libraries( ${PROJECT_NAME} ${CGAL_LIBRARIES} )
	target_compile_definitions( ${PROJECT_NAME} PRIVATE USE_CGAL_LIB )
endif()

if (COMPILE_CC_CORE_LIB_WITH_TBB)
	include_directories( ${TBB_INCLUDE_DIRS} )
	target_link_libraries( ${PROJECT_NAME} ${TBB_LIBRARIES} )
	target_compile_definitions( ${PROJECT_NAME} PRIVATE USE_TBB )
endif()

if ( COMPILE_CC_CORE_LIB_WITH_QT )
	include_directories( ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} )
	target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Widgets Qt5::Concurrent)
	target_compile_definitions( ${PROJECT_NAME} PRIVATE USE_QT )
endif()

# Load advanced scripts
include( CMakeInclude )

if ( COMPILE_CC_CORE_LIB_SHARED )
	# Install (shared) library to specified destinations
	if( WIN32 OR APPLE )
		foreach( dest ${INSTALL_DESTINATIONS} )
			install_shared( CC_CORE_LIB ${dest} 1 )
		endforeach()
	else()
		install_shared( CC_CORE_LIB ${CMAKE_INSTALL_LIBDIR}/cloudcompare 0 ) #default destination: /usr/lib/cloudcompare
	endif()
endif()

if (WIN32)
	target_compile_definitions( ${PROJECT_NAME} PRIVATE _CRT_SECURE_NO_WARNINGS )
endif()

set( CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DCC_DEBUG" )
set( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DCC_DEBUG" )

=== ccViewer/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project( ccViewer VERSION 1.39.0 )

include( CMakePolicies NO_POLICY_SCOPE )

include_directories( ${CC_FBO_LIB_SOURCE_DIR}/include )
include_directories( ${CC_CORE_LIB_SOURCE_DIR}/include )
include_directories( ${QCC_DB_LIB_SOURCE_DIR} )
if( MSVC )
   include_directories( ${QCC_DB_LIB_SOURCE_DIR}/msvc )
endif()
include_directories( ${QCC_IO_LIB_SOURCE_DIR} )
include_directories( ${QCC_GL_LIB_SOURCE_DIR} )
include_directories( ${CloudComparePlugins_SOURCE_DIR} )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/../common )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/../qCC )
include_directories( ${CMAKE_CURRENT_BINARY_DIR} )

file( GLOB header_list *.h )
file( GLOB source_list *.cpp )

file( GLOB ui_list ui_templates/*.ui )
file( GLOB qrc_list ../qCC/*.qrc )
file( GLOB rc_list ../qCC/*.rc )

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../common ${CMAKE_CURRENT_BINARY_DIR}/common)

# 3DX support (3dConnexion devices)
if ( ${OPTION_SUPPORT_3DCONNEXION_DEVICES} )
	add_subdirectory( ../qCC/devices/3dConnexion devices/3dConnexion )
endif()

# Gamepad support (requires Qt 5.7+)
if ( ${OPTION_SUPPORT_GAMEPADS} )
	add_subdirectory( ../qCC/devices/gamepad devices/gamepad )
endif()

qt5_wrap_ui( generated_ui_list ${ui_list} )
qt5_add_resources( generated_qrc_list ${qrc_list} )

if( MSVC )
	# App icon with MSVC
	set( rc_list images/icon/cc_viewer_icon.rc )

	#to get rid of the (system) console
	add_executable( ${PROJECT_NAME} WIN32 ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${rc_list})
elseif( APPLE )
	add_executable( ${PROJECT_NAME} MACOSX_BUNDLE ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${rc_list})
else()
	add_executable( ${PROJECT_NAME} ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${rc_list})
endif()

target_link_libraries( ${PROJECT_NAME}
	CC_FBO_LIB
	CC_CORE_LIB
	QCC_DB_LIB
	QCC_IO_LIB
	QCC_GL_LIB )

# Qt
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Gui Qt5::Widgets Qt5::OpenGL)
if (WIN32)
	target_link_libraries( ${PROJECT_NAME} Qt5::WinMain )
endif()

# contrib. libraries support
if ( APPLE )
	target_link_contrib( ${PROJECT_NAME} ${CLOUDCOMPARE_MAC_FRAMEWORK_DIR} )
elseif( UNIX )
	target_link_contrib( ${PROJECT_NAME} ${CMAKE_INSTALL_LIBDIR}/cloudcompare )
else()
	target_link_contrib( ${PROJECT_NAME} ${CCVIEWER_DEST_FOLDER} )
endif()

# 3dConnexion devices support
if ( ${OPTION_SUPPORT_3DCONNEXION_DEVICES} )
	target_link_3DXWARE( ${PROJECT_NAME} )
endif()

# Gamepad support (requires Qt 5.7+)
if ( ${OPTION_SUPPORT_GAMEPADS} )
	target_link_GAMEPADS( ${PROJECT_NAME} )
endif()

# Add custom preprocessor definitions
target_compile_definitions( ${PROJECT_NAME} PUBLIC CC_VIEWER )

if (OPTION_GL_QUAD_BUFFER_SUPPORT)
	target_compile_definitions( ${PROJECT_NAME} PUBLIC CC_GL_WINDOW_USE_QWINDOW )
endif()

if (WIN32)
	if (MSVC)
		set_target_properties( ${PROJECT_NAME} PROPERTIES LINK_FLAGS " /MANIFEST:NO" )
	endif()
endif()

# App icon with Code::Blocks/MinGW
if( WIN32 )
	if( MINGW )
		add_custom_command( TARGET ${PROJECT_NAME} PRE_BUILD COMMAND ${CMAKE_RC_COMPILER} -i ${CMAKE_CURRENT_SOURCE_DIR}/images/icon/cc_viewer_icon.rc --input-format=rc -o ${CMAKE_CURRENT_BINARY_DIR}/ccViewer.res -O coff )
	endif()
endif()

# install program
install_ext( TARGETS ccViewer ${CCVIEWER_DEST_FOLDER} )

# Auxiliary files
set( auxFiles bin_other/license.txt )

if( WIN32 )
	# Export Qt dlls
	install_Qt_Dlls( ${CCVIEWER_DEST_FOLDER} ${OPTION_SUPPORT_GAMEPADS} )
	install_Qt5_plugins( ${CCVIEWER_DEST_FOLDER} )

	# Additional auxiliary file(s)
	list( APPEND auxFiles bin_other/start.bat )
endif()

# Install auxiliary files
if(APPLE OR WIN32) # For Linux it's already installed in by qCC
	foreach( filename ${auxFiles} )
		install_ext( FILES ${filename} ${CCVIEWER_DEST_FOLDER} )
	endforeach()
endif()

# Put together our Application bundle on macOS
if( APPLE )
	add_subdirectory( Mac )
endif( APPLE )

# Export common shader files to all install destinations
if( WIN32 ) # For Linux it's already installed in by qCC
	install_ext( FILES ${CMAKE_CURRENT_SOURCE_DIR}/../qCC/shaders/ColorRamp/color_ramp.frag ${CCVIEWER_DEST_FOLDER} /shaders/ColorRamp )
endif()

=== common/CMakeLists.txt ===
set(header_list
   ${header_list}
   ${CMAKE_CURRENT_SOURCE_DIR}/ccApplicationBase.h
   ${CMAKE_CURRENT_SOURCE_DIR}/ccCameraParamEditDlg.h
   ${CMAKE_CURRENT_SOURCE_DIR}/ccDisplayOptionsDlg.h
   ${CMAKE_CURRENT_SOURCE_DIR}/ccOptions.h
   ${CMAKE_CURRENT_SOURCE_DIR}/ccOverlayDialog.h
   ${CMAKE_CURRENT_SOURCE_DIR}/ccPickingListener.h
   ${CMAKE_CURRENT_SOURCE_DIR}/ccPickingHub.h
   ${CMAKE_CURRENT_SOURCE_DIR}/ccPickOneElementDlg.h
   ${CMAKE_CURRENT_SOURCE_DIR}/ccPluginManager.h
   ${CMAKE_CURRENT_SOURCE_DIR}/ccStereoModeDlg.h
   ${CMAKE_CURRENT_SOURCE_DIR}/ccQtHelpers.h
   ${CMAKE_CURRENT_SOURCE_DIR}/ccTranslationManager.h
   PARENT_SCOPE
)

set(source_list
   ${source_list}
   ${CMAKE_CURRENT_SOURCE_DIR}/ccApplicationBase.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/ccCameraParamEditDlg.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/ccDisplayOptionsDlg.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/ccOptions.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/ccOverlayDialog.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/ccPickingHub.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/ccPickOneElementDlg.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/ccPluginManager.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/ccStereoModeDlg.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/ccTranslationManager.cpp
   PARENT_SCOPE
)

set(ui_list
   ${ui_list}
   ${CMAKE_CURRENT_SOURCE_DIR}/ui_templates/cameraParamDlg.ui
   ${CMAKE_CURRENT_SOURCE_DIR}/ui_templates/displayOptionsDlg.ui
   ${CMAKE_CURRENT_SOURCE_DIR}/ui_templates/pickOneElementDlg.ui
   ${CMAKE_CURRENT_SOURCE_DIR}/ui_templates/stereoModeDlg.ui
   PARENT_SCOPE
)

=== qCC/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project( CloudCompare VERSION 2.11.3 )

include( CMakePolicies NO_POLICY_SCOPE )

include_directories( ${CC_FBO_LIB_SOURCE_DIR}/include )
include_directories( ${CC_CORE_LIB_SOURCE_DIR}/include )
include_directories( ${QCC_DB_LIB_SOURCE_DIR} )
if( MSVC )
   include_directories( ${QCC_DB_LIB_SOURCE_DIR}/msvc )
endif()
include_directories( ${QCC_IO_LIB_SOURCE_DIR} )
include_directories( ${QCC_GL_LIB_SOURCE_DIR} )
include_directories( ${CloudComparePlugins_SOURCE_DIR} )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/../common )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/db_tree )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/ui_templates )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/../libs/qcustomplot )
include_directories( ${CMAKE_CURRENT_BINARY_DIR} )

file( GLOB header_list *.h  )
file( GLOB source_list *.cpp )

file( GLOB ui_list ui_templates/*.ui )
file( GLOB qrc_list *.qrc )

file( GLOB txt_list TODO.txt ${CloudCompareProjects_SOURCE_DIR}/CHANGELOG.md )

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../common ${CMAKE_CURRENT_BINARY_DIR}/common)
add_subdirectory( db_tree )
add_subdirectory( pluginManager )

# 3DX support (3dConnexion devices)
if ( ${OPTION_SUPPORT_3DCONNEXION_DEVICES} )
	add_subdirectory( devices/3dConnexion )
endif()	

# Gamepad support (requires Qt 5.7+)
if ( ${OPTION_SUPPORT_GAMEPADS} )
	add_subdirectory( devices/gamepad )
endif()	

qt5_wrap_ui( generated_ui_list ${ui_list} )
qt5_add_resources( generated_qrc_list ${qrc_list} )

if( MSVC )
	# App icon with MSVC
	set( rc_list images/icon/cc_icon.rc )

	#to get rid of the (system) console
	add_executable( ${PROJECT_NAME} WIN32 ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${rc_list} ${txt_list} )
elseif( APPLE )
	add_executable( ${PROJECT_NAME} MACOSX_BUNDLE ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${txt_list} )
else()
	add_executable( ${PROJECT_NAME} ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${rc_list} ${txt_list} )
endif()

target_link_libraries( ${PROJECT_NAME}
	CC_FBO_LIB
	CC_CORE_LIB
	QCC_DB_LIB
	QCC_IO_LIB 
	QCC_GL_LIB
	qcustomplot )

# Qt
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Gui Qt5::Widgets Qt5::OpenGL Qt5::PrintSupport)
if (WIN32)
	target_link_libraries( ${PROJECT_NAME} Qt5::WinMain )
endif()

# contrib. libraries support
if( APPLE )
	target_link_contrib( ${PROJECT_NAME} ${CLOUDCOMPARE_MAC_FRAMEWORK_DIR} )
elseif( UNIX )
	target_link_contrib( ${PROJECT_NAME} lib/cloudcompare )
else()
	target_link_contrib( ${PROJECT_NAME} ${CLOUDCOMPARE_DEST_FOLDER} )
endif()

# 3dConnexion devices support
if ( ${OPTION_SUPPORT_3DCONNEXION_DEVICES} )
	target_link_3DXWARE( ${PROJECT_NAME} )
endif()
# Gamepad support (requires Qt 5.7+)
if ( ${OPTION_SUPPORT_GAMEPADS} )
	target_link_GAMEPADS( ${PROJECT_NAME} )
endif()

# Add custom preprocessor definitions
if (OPTION_GL_QUAD_BUFFER_SUPPORT)
	target_compile_definitions( ${PROJECT_NAME} PUBLIC CC_GL_WINDOW_USE_QWINDOW )
endif()
if( WIN32 )
	if (MSVC)
		set_target_properties( ${PROJECT_NAME} PROPERTIES LINK_FLAGS " /MANIFEST:NO" )
	endif()
endif()

# App icon with Code::Blocks/MinGW
if( WIN32 )
	if( MINGW )
		if (NOT CMAKE_RC_COMPILER)
			set( CMAKE_RC_COMPILER windres )
		endif()
		add_custom_command( TARGET ${PROJECT_NAME} PRE_BUILD COMMAND ${CMAKE_RC_COMPILER} -i ${CMAKE_CURRENT_SOURCE_DIR}/images/icon/cc_icon.rc --input-format=rc -o ${CMAKE_CURRENT_BINARY_DIR}/cc_icon.res -O coff )
	endif()
endif()

# install program
install_ext( TARGETS ${PROJECT_NAME} ${CLOUDCOMPARE_DEST_FOLDER} )

# Auxiliary files
set( auxFiles  ${CloudCompareProjects_SOURCE_DIR}/CHANGELOG.md bin_other/license.txt bin_other/global_shift_list_template.txt )

if( WIN32 )
	# Export Qt dlls
	install_Qt_Dlls( ${CLOUDCOMPARE_DEST_FOLDER} ${OPTION_SUPPORT_GAMEPADS} )
	install_Qt_ImageFormats( ${CLOUDCOMPARE_DEST_FOLDER} )
	install_Qt5_plugins( ${CLOUDCOMPARE_DEST_FOLDER} )

	# Additional auxiliary file(s)
	file( GLOB batch_list bin_other/*.bat )
	list( APPEND auxFiles ${batch_list} )
endif()

# Install auxiliary files
if( WIN32 OR APPLE )
	foreach( filename ${auxFiles} )
		install_ext( FILES ${filename} ${CLOUDCOMPARE_DEST_FOLDER} )
	endforeach()
else( UNIX )
	foreach( filename ${auxFiles} )
		install_ext( FILES ${filename} share/cloudcompare )
	endforeach()
endif()

# Translation
add_subdirectory( translations )

# Put together our Application bundle on macOS
if( APPLE )    
    add_subdirectory( Mac )
endif()

## Shaders
# Copy shader dirs into our shadow build directory
file( COPY ${CC_FBO_LIB_SOURCE_DIR}/shaders DESTINATION "${CMAKE_BINARY_DIR}" )
file( COPY ${CMAKE_CURRENT_SOURCE_DIR}/shaders DESTINATION "${CMAKE_BINARY_DIR}" )

# Export common shader files to all install destinations
if( APPLE )	
	install( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.frag DESTINATION ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/Shaders/Bilateral )
	install( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.vert DESTINATION ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/Shaders/Bilateral )
	install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/shaders/ColorRamp/color_ramp.frag DESTINATION ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/Shaders/ColorRamp )
elseif( UNIX )
	install( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.frag DESTINATION share/cloudcompare/shaders/Bilateral )
	install( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.vert DESTINATION share/cloudcompare/shaders/Bilateral )
	install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/shaders/ColorRamp/color_ramp.frag DESTINATION share/cloudcompare/shaders/ColorRamp )
else()
	install_ext( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.frag ${CLOUDCOMPARE_DEST_FOLDER} /shaders/Bilateral )
	install_ext( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.vert ${CLOUDCOMPARE_DEST_FOLDER} /shaders/Bilateral )
	install_ext( FILES ${CMAKE_CURRENT_SOURCE_DIR}/shaders/ColorRamp/color_ramp.frag ${CLOUDCOMPARE_DEST_FOLDER} /shaders/ColorRamp )
endif()

=== contrib/dxflib-3.17.0/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

# CC custom (external) CMake script for Ribbonsoft's DXF Lib
project( DXF_LIB )

# no Qt stuff here
set( CMAKE_AUTOMOC OFF )
set( CMAKE_AUTOUIC OFF )
set( CMAKE_AUTORCC OFF )

file( GLOB header_list src/*.h)
file( GLOB source_list src/*.cpp)

add_library( ${PROJECT_NAME} STATIC ${header_list} ${source_list} )

if (WIN32)
	target_compile_definitions( ${PROJECT_NAME} PRIVATE _CRT_SECURE_NO_DEPRECATE )
endif()

=== contrib/shapelib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project( SHAPELIB )

# no Qt stuff here
set( CMAKE_AUTOMOC OFF )
set( CMAKE_AUTOUIC OFF )
set( CMAKE_AUTORCC OFF )

file( GLOB header_list *.h )
file( GLOB source_list *.c )

add_library( ${PROJECT_NAME} STATIC ${header_list} ${source_list} )

=== libs/qCC_db/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

include_directories( ${CC_CORE_LIB_SOURCE_DIR}/include )
include_directories( ${CC_FBO_LIB_SOURCE_DIR}/include )

project( QCC_DB_LIB )

file( GLOB header_list *.h)
file( GLOB source_list *.cpp)

set( CMAKE_CXX_VISIBILITY_PRESET hidden )

add_library( ${PROJECT_NAME} SHARED ${header_list} ${source_list} )

target_link_libraries( ${PROJECT_NAME}
	CC_CORE_LIB
	CC_FBO_LIB )

# Qt
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Gui Qt5::Widgets Qt5::OpenGL)

# Add custom preprocessor definitions
target_compile_definitions( ${PROJECT_NAME} PRIVATE QCC_DB_LIBRARY_BUILD )

# install (shared) lib to specified destinations
if( WIN32 OR APPLE )
	foreach( dest ${INSTALL_DESTINATIONS} )
		install_shared( ${PROJECT_NAME} ${dest} 1 )
	endforeach()
else()
	install_shared( ${PROJECT_NAME} ${CMAKE_INSTALL_LIBDIR}/cloudcompare 0 ) #default destination: /usr/lib
endif()

=== libs/qCC_glWindow/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

include_directories( ${CC_CORE_LIB_SOURCE_DIR}/include )
include_directories( ${CC_FBO_LIB_SOURCE_DIR}/include )
include_directories( ${QCC_DB_LIB_SOURCE_DIR} )
if( MSVC )
   include_directories( ${QCC_DB_LIB_SOURCE_DIR}/msvc )
endif()

project( QCC_GL_LIB )

file( GLOB header_list *.h)
file( GLOB source_list *.cpp)

add_library( ${PROJECT_NAME} STATIC ${header_list} ${source_list} )

target_link_libraries( ${PROJECT_NAME}
	CC_CORE_LIB
	QCC_DB_LIB
	CC_FBO_LIB )

# OCULUS support
target_link_OCULUS_SDK( ${PROJECT_NAME} )

# Qt
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Gui Qt5::Widgets Qt5::OpenGL Qt5::OpenGLExtensions)

# Add custom preprocessor definitions
if (OPTION_GL_QUAD_BUFFER_SUPPORT)
	target_compile_definitions( ${PROJECT_NAME} PRIVATE CC_GL_WINDOW_USE_QWINDOW )
endif()

=== libs/qCC_io/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

include( CMakePolicies NO_POLICY_SCOPE )

include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
include_directories( ${CC_CORE_LIB_SOURCE_DIR}/include )
include_directories( ${CC_FBO_LIB_SOURCE_DIR}/include )
include_directories( ${QCC_DB_LIB_SOURCE_DIR} )
if( MSVC )
   include_directories( ${QCC_DB_LIB_SOURCE_DIR}/msvc )
endif()
include_directories( ${CMAKE_CURRENT_BINARY_DIR} )

project( QCC_IO_LIB )

file( GLOB header_list *.h)
file( GLOB source_list *.cpp *.c)
file( GLOB ui_list ui_templates/*.ui )

set( CMAKE_CXX_VISIBILITY_PRESET hidden )

qt5_wrap_ui( generated_ui_list ${ui_list} )
add_library( ${PROJECT_NAME} SHARED ${header_list} ${source_list} ${generated_ui_list} )

target_link_libraries( ${PROJECT_NAME}
	CC_CORE_LIB
	CC_FBO_LIB
	QCC_DB_LIB )

# Qt
target_link_libraries(${PROJECT_NAME} Qt5::Core)	

# contrib. libraries support
target_link_contrib( ${PROJECT_NAME} )

# Add custom preprocessor definitions
target_compile_definitions( ${PROJECT_NAME} PRIVATE QCC_IO_LIBRARY_BUILD )

if( APPLE )
	set_target_properties( ${PROJECT_NAME} PROPERTIES
		INSTALL_RPATH "." )
endif()

# install (shared) lib to specified destinations
if( WIN32 OR APPLE )
	foreach( dest ${INSTALL_DESTINATIONS} )
		install_shared( ${PROJECT_NAME} ${dest} 1 )
	endforeach()
else()
	install_shared( ${PROJECT_NAME} ${CMAKE_INSTALL_LIBDIR}/cloudcompare 0 ) #default destination: /usr/lib
endif()

if(BUILD_TESTING)
	add_subdirectory(Tests)
endif()

=== plugins/3rdParty/CMakeLists.txt ===
# Auto add all subdirectories
file( GLOB subdirectories * )

foreach( dir ${subdirectories} )
    if( IS_DIRECTORY ${dir} AND EXISTS ${dir}/CMakeLists.txt )
		# in case the user generates the BUILD project in the same folder as the sources!
		if ( NOT ${dir} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR}/CMakeFiles )
			message( STATUS "Auto-add 3rd party plugin: " ${dir} )
			add_subdirectory ( ${dir} )
		endif()
	endif()
endforeach()

=== qCC/Mac/CMakeLists.txt ===
# Put together our App bundle on macOS
if( APPLE )
	set_target_properties( ${PROJECT_NAME} PROPERTIES
		INSTALL_RPATH "@executable_path/../Frameworks"
		MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/CloudCompare.plist
		MACOSX_BUNDLE_ICON_FILE cc_icon.icns
		MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}"
		MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_VERSION}"
		MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_VERSION}" )

	set( CLOUDCOMPARE_MAC_BASE_DIR ${CMAKE_INSTALL_PREFIX}/${CLOUDCOMPARE_DEST_FOLDER}/CloudCompare.app  CACHE INTERNAL "CloudCompare bundle dir")
	set( CLOUDCOMPARE_MAC_FRAMEWORK_DIR ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/Frameworks CACHE INTERNAL "CC framework dir" )
	set( CLOUDCOMPARE_MAC_PLUGIN_DIR ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/PlugIns/ccPlugins CACHE INTERNAL "CC plugin dir" )
	
	# this will install all the Qt libs and the necessary plugins
	install( CODE "execute_process( COMMAND \"${MACDEPLOYQT}\" \"${CLOUDCOMPARE_MAC_BASE_DIR}\" -verbose=1 )" COMPONENT Runtime )
	
	# install icons
	install( FILES cc_icon.icns DESTINATION ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/Resources COMPONENT Runtime )   
endif( APPLE )

=== debian/changelog ===
cloudcompare (2.11.3-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * CVE-2021-21897: Heap-based buffer overflow loading a DXF file.
    (Closes: #1010347)

 -- Adrian Bunk <bunk@debian.org>  Fri, 07 Apr 2023 14:45:46 +0300

cloudcompare (2.11.3-7) unstable; urgency=medium

  * Drop png extension from desktop files. (Closes: #1021335)

 -- Gürkan Myczko <tar@debian.org>  Mon, 10 Oct 2022 14:52:30 +0200

cloudcompare (2.11.3-6) unstable; urgency=medium

  * debian/patches/ffmpeg-5.0.patch: compatibility with ffmpeg 5.0.
    (Closes: #1004801), thanks Steve Langasek for the patch.

 -- Gürkan Myczko <tar@debian.org>  Tue, 16 Aug 2022 11:59:26 +0200

cloudcompare (2.11.3-5) unstable; urgency=medium

  * Drop PDAL & LASzip from build dependencies, the packages will be removed.
    Thanks for the patches Bas Couwenberg.
    (Closes: #1006910, #1007126, #1007127)

 -- Gürkan Myczko <tar@debian.org>  Mon, 21 Mar 2022 08:24:58 +0100

cloudcompare (2.11.3-4) unstable; urgency=medium

  * Apply patch to fix FTBFS. (Closes: #996589)
    Thanks Adrian Bunk.

 -- Gürkan Myczko <tar@debian.org>  Wed, 17 Nov 2021 12:08:34 +0100

cloudcompare (2.11.3-3) unstable; urgency=medium

  * d/rules:
    - replace ffmpeg x86_64-linux-gnu parameters with $(DEBARCH)
      Thanks Adrian Bunk for the hint.
    - sed the right part for plugins directory.
  * Update maintainer address.

 -- Gürkan Myczko <tar@debian.org>  Wed, 17 Nov 2021 09:29:07 +0100

cloudcompare (2.11.3-2) unstable; urgency=medium

  * Upload to unstable.
  * d/copyright: update file patterns.
  * Bump standards versino to 4.6.0.
  * d/rules: update cmake parameters for plugins.
  * d/control: add libeigen3-dev to Build-Depends.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 11 Oct 2021 09:16:20 +0200

cloudcompare (2.11.3-1) experimental; urgency=medium

  * New upstream version.
  * Bump debhelper version to 13, drop d/compat.
  * Bump standards version to 4.5.0.
  * d/patches: dropped.
  * d/ccApplicationBase.cpp: dh_clean patch dropped from d/rules.
  * d/upstream/metadata: added.
  * d/control: added Rules-Requires-Root.
  * d/copyright: update copyright years.
  * d/clean: added.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 20 Nov 2020 15:03:44 +0100

=== debian/control ===
Source: cloudcompare
Section: graphics
Priority: optional
Maintainer: Gürkan Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, libqt5opengl5-dev, libcgal-dev, libdxflib-dev (>= 2.5.0),
 libglew-dev, libfreenect-dev, libgdal-dev, libgomp1, libboost-all-dev, libavcodec-dev, libavformat-dev, libswscale-dev, libeigen3-dev,
 libjsoncpp-dev, libcurl4-gnutls-dev | libcurl4-openssl-dev, libcgal-qt5-dev, libqt5svg5-dev, qttools5-dev-tools, qttools5-dev
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://www.danielgm.net/cc/

Package: cloudcompare
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 3D point cloud and mesh processing software
 This is a 3D point cloud (and triangular mesh) processing software. It has
 been originally designed to perform comparison between two 3D points clouds
 (such as the ones obtained with a laser scanner) or between a point cloud
 and a triangular mesh.
 .
 It relies on a specific octree structure that enables great performances in
 this particular function. It was also meant to deal with huge point clouds
 (typically more than 10 millions points, and up to 120 millions with 2 GB
 of memory)

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS

DEBARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DH_VERBOSE=1

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

override_dh_auto_configure:
	$(shell sed -i s,lib/x86_64-linux-gnu/cloudcompare/plugins,lib/$(DEBARCH)/cloudcompare/plugins,g common/ccApplicationBase.cpp)
	#$(shell sed -i s,lib/cloudcompare/plugins,lib/$(DEBARCH)/cloudcompare/plugins,g common/ccApplicationBase.cpp)
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DOPTION_USE_LIBLAS=OFF \
		-DOPTION_PDAL_LAS=OFF \
		-DCOMPILE_CC_CORE_LIB_WITH_CGAL=OFF \
		-DJSON_ROOT_DIR=/usr/include/jsoncpp \
		-DWITH_FFMPEG_SUPPORT=ON \
		-DFFMPEG_INCLUDE_DIR="/usr/include/$(DEBARCH)" \
		-DFFMPEG_LIBRARY_DIR="/usr/lib/$(DEBARCH)" \
		-DINSTALL_QBLUR_PLUGIN=ON \
		-DPLUGIN_GL_QEDL=ON \
		-DPLUGIN_STANDARD_QPCV=ON \
		-DPLUGIN_STANDARD_QSRA=ON \
		-DPLUGIN-STANDARD_QBROOM=ON \
		-DPLUGIN-STANDARD_QCSF=ON \
		-DPLUGIN-STANDARD_QHPR=ON \
		-DPLUGIN-STANDARD_QM3C2=ON \
		-DPLUGIN_IO_QPDAL=OFF \
		-DPLUGIN_IO_QPHOTOSCAN=ON \
		-DPLUGIN_STANDARD_QRANSAC_SD=ON \
		-DPLUGIN_STANDARD_QANIMATION=ON \
		-DPLUGIN_STANDARD_QCOMPASS=ON \
		-DPLUGIN_STANDARD_QHOUGH_NORMALS=ON \
		-DINSTALL_QSSAO_PLUGIN=ON \
		-DINSTALL_QANIMATION_PLUGIN=ON \
		-DINSTALL_QGMMREG_PLUGIN=ON \
		-DOPTION_USE_DXF_LIB=ON \
		-DEIGEN_ROOT_DIR=/usr/include/eigen3 \
		-DCOMPILE_CC_CORE_LIB_WITH_TBB=OFF

#		-DCMAKE_BUILD_TYPE=Release \
#		-DOPTION_USE_LIBLAS=ON \
#		-DCOMPILE_CC_CORE_LIB_WITH_CGAL=OFF \
#		-DJSON_ROOT_DIR=/usr/include/jsoncpp \
#		-DWITH_FFMPEG_SUPPORT=ON \
#		-DFFMPEG_INCLUDE_DIR="/usr/include/$(DEBARCH)" \
#		-DFFMPEG_LIBRARY_DIR="/usr/lib/$(DEBARCH)" \
#		-DINSTALL_QBLUR_PLUGIN=ON

#		-DCMAKE_BUILD_TYPE=Release \
#		-DINSTALL_QHOUGH_NORMALS_PLUGIN=true \
#		-DINSTALL_QPOISSON_RECON_PLUGIN=ON \
#		-DPOISSON_RECON_WITH_OPEN_MP=ON \
#		-DOPTION_USE_GDAL=ON \
#		-DOPTION_USE_DXF_LIB=ON \
#		-DINSTALL_QPHOTOSCAN_IO_PLUGIN=ON \
#		-DOPTION_USE_SHAPE_LIB=ON \
#		-DEIGEN_ROOT_DIR=/usr/include/eigen3 \

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/cloudcompare $(DEBARCH)

## cloudcompare 2.11.3+git20220202+ds

=== debian/changelog ===
cloudcompare (2.11.3+git20220202+ds-1) experimental; urgency=medium

  * New upstream version.
  * Update maintainer address.
  * d/copyright: bump years.

 -- Gürkan Myczko <tar@debian.org>  Wed, 02 Feb 2022 15:20:50 +0100

## cloudcompare 2.13~git20230616+ds

=== debian/changelog ===
cloudcompare (2.13~git20230616+ds-2) experimental; urgency=medium

  * d/rules: also use CGAL. (Closes: #1041469)

 -- Gürkan Myczko <tar@debian.org>  Mon, 24 Jul 2023 13:56:42 +0200

cloudcompare (2.13~git20230616+ds-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Fri, 16 Jun 2023 15:00:18 +0200

cloudcompare (2.13~git20230321+ds-1) experimental; urgency=medium

  * New upstream version.
  * Bump standards version to 4.6.2.
  * d/rules: enable PLUGIN_STANDARD_QPCL. (Closes: #1020278)
  * d/control:
    - add libpcl-dev.
    - add Vcs fields.

 -- Gürkan Myczko <tar@debian.org>  Tue, 21 Mar 2023 13:07:07 +0100

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,11 @@
 Maintainer: Gürkan Myczko <tar@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake, libqt5opengl5-dev, libcgal-dev, libdxflib-dev (>= 2.5.0),
  libglew-dev, libfreenect-dev, libgdal-dev, libgomp1, libboost-all-dev, libavcodec-dev, libavformat-dev, libswscale-dev, libeigen3-dev,
- libjsoncpp-dev, libcurl4-gnutls-dev | libcurl4-openssl-dev, libcgal-qt5-dev, libqt5svg5-dev, qttools5-dev-tools, qttools5-dev
-Standards-Version: 4.6.0
+ libjsoncpp-dev, libcurl4-gnutls-dev | libcurl4-openssl-dev, libcgal-qt5-dev, libqt5svg5-dev, qttools5-dev-tools, qttools5-dev, libpcl-dev
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
+Vcs-Git: https://salsa.debian.org/debian/cloudcompare.git
+Vcs-Browser: https://salsa.debian.org/debian/cloudcompare
 Homepage: https://www.danielgm.net/cc/
 
 Package: cloudcompare

=== debian/rules ===
--- 
+++ 
@@ -36,6 +36,7 @@
 		-DPLUGIN_STANDARD_QANIMATION=ON \
 		-DPLUGIN_STANDARD_QCOMPASS=ON \
 		-DPLUGIN_STANDARD_QHOUGH_NORMALS=ON \
+		-DPLUGIN_STANDARD_QPCL=ON \
 		-DINSTALL_QSSAO_PLUGIN=ON \
 		-DINSTALL_QANIMATION_PLUGIN=ON \
 		-DINSTALL_QGMMREG_PLUGIN=ON \
@@ -57,7 +58,6 @@
 #		-DINSTALL_QPOISSON_RECON_PLUGIN=ON \
 #		-DPOISSON_RECON_WITH_OPEN_MP=ON \
 #		-DOPTION_USE_GDAL=ON \
-#		-DOPTION_USE_DXF_LIB=ON \
 #		-DINSTALL_QPHOTOSCAN_IO_PLUGIN=ON \
 #		-DOPTION_USE_SHAPE_LIB=ON \
 #		-DEIGEN_ROOT_DIR=/usr/include/eigen3 \

## cloudcompare 2.13.2%2Bgit20240821%2Bds

=== libs/CMakeLists.txt ===
add_subdirectory( CCAppCommon)
add_subdirectory( CCFbo )
add_subdirectory( CCPluginStub )    # Must come before CCPluginAPI
add_subdirectory( CCPluginAPI )
add_subdirectory( qCC_db )
add_subdirectory( qCC_glWindow )
add_subdirectory( qCC_io )

=== plugins/core/CMakeLists.txt ===

add_subdirectory( GL )
add_subdirectory( IO )
add_subdirectory( Standard )

=== libs/CCAppCommon/ui/CMakeLists.txt ===

target_sources( ${PROJECT_NAME}
	PRIVATE
		${CMAKE_CURRENT_LIST_DIR}/cameraParamDlg.ui
		${CMAKE_CURRENT_LIST_DIR}/displayOptionsDlg.ui
		${CMAKE_CURRENT_LIST_DIR}/pickOneElementDlg.ui
		${CMAKE_CURRENT_LIST_DIR}/stereoModeDlg.ui
)

set_target_properties( ${PROJECT_NAME} PROPERTIES
	AUTOUIC_SEARCH_PATHS ${CMAKE_CURRENT_LIST_DIR}
)

=== libs/CCFbo/include/CMakeLists.txt ===

target_sources( ${PROJECT_NAME}
	PRIVATE
		${CMAKE_CURRENT_LIST_DIR}/ccBilateralFilter.h
		${CMAKE_CURRENT_LIST_DIR}/CCFbo.h
		${CMAKE_CURRENT_LIST_DIR}/ccFrameBufferObject.h
		${CMAKE_CURRENT_LIST_DIR}/ccGlFilter.h
		${CMAKE_CURRENT_LIST_DIR}/ccShader.h
)

target_include_directories( ${PROJECT_NAME}
	PUBLIC
	    ${CMAKE_CURRENT_LIST_DIR}
)

=== plugins/core/Standard/CMakeLists.txt ===
add_subdirectory( qAnimation )
add_subdirectory( qBroom )
add_subdirectory( qCanupo )
add_subdirectory( qCloudLayers )
add_subdirectory( qCompass )
add_subdirectory( qCork )
add_subdirectory( qCSF )
add_subdirectory( qFacets )
add_subdirectory( qHoughNormals )
add_subdirectory( qHPR )
add_subdirectory( qM3C2 )
add_subdirectory( qPCL )
add_subdirectory( qPCV )
add_subdirectory( qPoissonRecon )
add_subdirectory( qRANSAC_SD )
add_subdirectory( qSRA )
add_subdirectory( qMeshBoolean )

#plugins integrated as submodules
set( submod_plugins
		${CMAKE_CURRENT_SOURCE_DIR}/qColorimetricSegmenter
		${CMAKE_CURRENT_SOURCE_DIR}/qMasonry
		${CMAKE_CURRENT_SOURCE_DIR}/qMPlane
		${CMAKE_CURRENT_SOURCE_DIR}/qJSonRPCPlugin
		${CMAKE_CURRENT_SOURCE_DIR}/qTreeIso
		${CMAKE_CURRENT_SOURCE_DIR}/q3DMASC
)

foreach( dir ${submod_plugins} )
    if( IS_DIRECTORY ${dir} AND EXISTS ${dir}/CMakeLists.txt )
		message( STATUS "Found submodule plugin: " ${dir} )
		add_subdirectory( ${dir} )
	endif()
endforeach()

=== plugins/core/GL/qEDL/CMakeLists.txt ===
option( PLUGIN_GL_QEDL "Install qEDL plugin" OFF )

if( PLUGIN_GL_QEDL )
	project( QEDL_GL_PLUGIN )
	
	AddPlugin(
		NAME ${PROJECT_NAME}
		TYPE gl
		SHADER_FOLDER EDL
	)
	
	add_subdirectory( include )
	add_subdirectory( src )
	add_subdirectory( shaders )
endif()

=== plugins/core/IO/qCSVMatrixIO/CMakeLists.txt ===
option( PLUGIN_IO_QCSV_MATRIX "Install qCSVMatrix I/O plugin" OFF )

if( PLUGIN_IO_QCSV_MATRIX )
	project( QCSV_MATRIX_IO_PLUGIN )
	
	AddPlugin( NAME ${PROJECT_NAME} TYPE io )
		
	add_subdirectory( include )
	add_subdirectory( src )
	add_subdirectory( ui )
endif()

=== plugins/core/IO/qDracoIO/CMakeLists.txt ===
option( PLUGIN_IO_QDRACO "Install qDracoIO plugin to read & write DRC files" OFF )

if( PLUGIN_IO_QDRACO )
	project( QDRACO_IO_PLUGIN )

	find_package( Draco REQUIRED )

	AddPlugin( NAME ${PROJECT_NAME} TYPE io )

	if( MSVC )

		target_include_directories( ${PROJECT_NAME} PRIVATE ${DRACO_INCLUDE_DIRS} )
		target_link_libraries( ${PROJECT_NAME} ${Draco_DIR}/../../lib/${DRACO_LIBRARIES}.lib )

	elseif( UNIX )

		target_include_directories( ${PROJECT_NAME} PRIVATE ${DRACO_INCLUDE_DIR} )
		set ( DRACO_INCLUDE_DIR "" CACHE PATH "Draco include dir" )
		set ( DRACO_LIB_DIR "" CACHE PATH "Draco library dir" )
		
		if( NOT DRACO_INCLUDE_DIR )
			message( FATAL_ERROR "Draco include dir not specified (DRACO_INCLUDE_DIR)" )
		endif()
		if( NOT DRACO_LIB_DIR )
			message( FATAL_ERROR "Draco library dir not specified (DRACO_LIB_DIR)" )
		endif()
		
		target_link_libraries( ${PROJECT_NAME} ${DRACO_LIBRARIES} )

	elseif()

		target_link_libraries( ${PROJECT_NAME} ${DRACO_LIBRARIES} )

	endif()

	add_subdirectory( include )
	add_subdirectory( src )
	add_subdirectory( ui )
 
endif()

=== plugins/core/Standard/q3DMASC/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

option( PLUGIN_STANDARD_3DMASC "Check to install q3DMASC plugin" OFF )

if (PLUGIN_STANDARD_3DMASC)

	#New classification plugin (Dimitri Lague/OSUR)
	project( Q3DMASC_PLUGIN )

	AddPlugin( NAME ${PROJECT_NAME} )
	set(Q3DMASC_PLUGIN_VERSION "1.1")

	include( CMakePolicies NO_POLICY_SCOPE )

	#need OpenCV
	find_package( OpenCV REQUIRED )

	#As we are going to re-use several components of the main qCC project
	#we define its sources path relatively to the plugin's dir
	set(CloudCompare_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../../../qCC)

	#include the whole CC directory (easier)
	include_directories( ${CloudCompare_SOURCE_DIR} )
	#include_directories( ${OpenCV_INCLUDE_DIR} )

	file( GLOB PLUGIN_HDR_LIST ${CMAKE_CURRENT_SOURCE_DIR}/*.h )
	file( GLOB PLUGIN_SRC_LIST ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp )
	file( GLOB PLUGIN_UI_LIST ${CMAKE_CURRENT_SOURCE_DIR}/*.ui )

	#we need the "order choice" dialog
	file( GLOB CC_HDR_LIST ${CloudCompare_SOURCE_DIR}/ccOrderChoiceDlg*.h )
	file( GLOB CC_SRC_LIST ${CloudCompare_SOURCE_DIR}/ccOrderChoiceDlg*.cpp )
	set( CC_UI_LIST	${CloudCompare_SOURCE_DIR}/ui_templates/roleChoiceDlg.ui )

	# add source files
	target_sources( ${PROJECT_NAME}
		PRIVATE
			${PLUGIN_HDR_LIST}
			${PLUGIN_SRC_LIST}
			${PLUGIN_UI_LIST}
			${CC_HDR_LIST}
			${CC_SRC_LIST}
			${CC_UI_LIST})

	#include( CMakePluginTemplate )
	#include( ../../CMakePluginTpl.cmake )
	
	set_target_properties( ${PROJECT_NAME} PROPERTIES
		# FIXME Remove after everything has moved to targets
		AUTOUIC_SEARCH_PATHS "${CloudCompare_SOURCE_DIR}/ui_templates;${CMAKE_CURRENT_SOURCE_DIR}/ui")

	# FIXME These are required because we have dependencies outside of the api
	target_include_directories( ${PROJECT_NAME}
		PRIVATE
			${CloudCompare_SOURCE_DIR}
			${CloudCompare_SOURCE_DIR}/../common)

	target_link_libraries( ${PROJECT_NAME} ${OpenCV_LIBS} )
	set( OPENCV_DEP_DLL_FILES ${OpenCV_DIR}/x64/vc15/bin/opencv_world340.dll )
	copy_files("${OPENCV_DEP_DLL_FILES}" "${CLOUDCOMPARE_DEST_FOLDER}") #mind the quotes!

	#================
	# git commit hash
	# Get the current working branch
	execute_process(
		COMMAND git rev-parse --abbrev-ref HEAD
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		OUTPUT_VARIABLE GIT_BRANCH_3DMASC
		OUTPUT_STRIP_TRAILING_WHITESPACE)

	# Get the latest commit hash
	execute_process(
		COMMAND git rev-parse --short HEAD
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		OUTPUT_VARIABLE GIT_COMMIT_HASH_3DMASC
		OUTPUT_STRIP_TRAILING_WHITESPACE)

	# Get the latest commit hash
	execute_process(
		COMMAND git describe
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		OUTPUT_VARIABLE GIT_TAG_3DMASC
		OUTPUT_STRIP_TRAILING_WHITESPACE)

	# Get the current working branch
	execute_process(
		COMMAND git rev-parse --abbrev-ref HEAD
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		OUTPUT_VARIABLE GIT_BRANCH_CC
		OUTPUT_STRIP_TRAILING_WHITESPACE)

	# Get the latest commit hash
	execute_process(
		COMMAND git rev-parse --short HEAD
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		OUTPUT_VARIABLE GIT_COMMIT_HASH_CC
		OUTPUT_STRIP_TRAILING_WHITESPACE)

	message(${PROJECT_NAME} " " GIT_BRANCH_3DMASC " " ${GIT_BRANCH_3DMASC})
	message(${PROJECT_NAME} " " GIT_COMMIT_HASH_3DMASC " " ${GIT_COMMIT_HASH_3DMASC})
	message(${PROJECT_NAME} " " GIT_TAG_3DMASC " " ${GIT_TAG_3DMASC})
	message(${PROJECT_NAME} " " GIT_BRANCH_CC " " ${GIT_BRANCH_CC})
	message(${PROJECT_NAME} " " GIT_COMMIT_HASH_CC " " ${GIT_COMMIT_HASH_CC})
	message(${PROJECT_NAME} " " Q3DMASC_VERSION " " ${Q3DMASC_PLUGIN_VERSION})

	target_compile_definitions(${PROJECT_NAME} PRIVATE
		GIT_BRANCH_CC="${GIT_BRANCH_CC}"
		GIT_COMMMIT_HASH_CC="${GIT_COMMIT_HASH_CC}"
		PUBLIC GIT_BRANCH_3DMASC="${GIT_BRANCH_3DMASC}"
		GIT_COMMMIT_HASH_3DMASC="${GIT_COMMIT_HASH_3DMASC}"
		GIT_TAG_3DMASC="${GIT_TAG_3DMASC}"
		Q3DMASC_VERSION="${Q3DMASC_PLUGIN_VERSION}"
		)

endif()

=== plugins/core/Standard/qCloudLayers/CMakeLists.txt ===
option( PLUGIN_STANDARD_QCLOUDLAYERS "Install qCloudLayers release plugin" OFF )

if ( PLUGIN_STANDARD_QCLOUDLAYERS )
	project( QCLOUDLAYERS_PLUGIN )
	 
	AddPlugin( NAME ${PROJECT_NAME} )
		
	add_subdirectory( include )
	add_subdirectory( src )	
	add_subdirectory( ui )	
endif()

=== plugins/example/ExampleIOPlugin/src/CMakeLists.txt ===

target_sources( ${PROJECT_NAME}
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/ExampleIOPlugin.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FooFilter.cpp
)

=== plugins/example/ExamplePlugin/include/CMakeLists.txt ===

target_sources( ${PROJECT_NAME}
	PRIVATE
		${CMAKE_CURRENT_LIST_DIR}/ActionA.h
		${CMAKE_CURRENT_LIST_DIR}/ExamplePlugin.h
)

target_include_directories( ${PROJECT_NAME}
	PRIVATE
		${CMAKE_CURRENT_SOURCE_DIR}
)

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS

DEBARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DH_VERBOSE=1

%:
	dh $@
# --no-parallel

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

override_dh_auto_configure:
#	$(shell sed -i s,lib/x86_64-linux-gnu/cloudcompare/plugins,lib/$(DEBARCH)/cloudcompare/plugins,g common/ccApplicationBase.cpp)
#	#$(shell sed -i s,lib/cloudcompare/plugins,lib/$(DEBARCH)/cloudcompare/plugins,g common/ccApplicationBase.cpp)
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DCCCORELIB_USE_CGAL=ON \
		-DPLUGIN_IO_QLAS=ON \
		-DLASZIP_INCLUDE_DIR=/usr/include/laszip \
		-DOPTION_USE_GDAL=ON \
#		-DINSTALL_QBLUR_PLUGIN=ON \
#		-DPLUGIN_GL_QEDL=ON \
#		-DPLUGIN_STANDARD_QPCV=ON \
#		-DPLUGIN_STANDARD_QSRA=ON \
#		-DPLUGIN-STANDARD_QBROOM=ON \
#		-DPLUGIN-STANDARD_QCSF=ON \
#		-DPLUGIN-STANDARD_QHPR=ON \
#		-DPLUGIN-STANDARD_QM3C2=ON \
#		-DPLUGIN_IO_QPDAL=OFF \
#		-DPLUGIN_IO_QPHOTOSCAN=ON \
#		-DPLUGIN_STANDARD_QRANSAC_SD=ON \
#		-DPLUGIN_STANDARD_QANIMATION=ON \
#		-DPLUGIN_STANDARD_QCOMPASS=ON \
#		-DPLUGIN_STANDARD_QHOUGH_NORMALS=ON \
#		-DINSTALL_QSSAO_PLUGIN=ON \
#		-DINSTALL_QANIMATION_PLUGIN=ON \
#		-DINSTALL_QGMMREG_PLUGIN=ON \
#		-DOPTION_USE_DXF_LIB=ON \
#		-DCOMPILE_CC_CORE_LIB_WITH_TBB=OFF

#		-DCOMPILE_CC_CORE_LIB_WITH_CGAL=OFF \
#		-DINSTALL_QBLUR_PLUGIN=ON

#		-DINSTALL_QHOUGH_NORMALS_PLUGIN=true \
#		-DINSTALL_QPOISSON_RECON_PLUGIN=ON \
#		-DPOISSON_RECON_WITH_OPEN_MP=ON \
#		-DOPTION_USE_DXF_LIB=ON \
#		-DINSTALL_QPHOTOSCAN_IO_PLUGIN=ON \
#		-DOPTION_USE_SHAPE_LIB=ON \

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/cloudcompare $(DEBARCH)
